#include"glocal.h"
#include<fstream>
#include<algorithm>
using namespace std;

bool seq1StartCompare(const Fragment &f1, const Fragment &f2)
{
   return  f1.seq1Start < f2.seq1Start;
}

//vectors that would be neede globally
vector<Fragment> fragments;
Name allNames;
SortedSet scoreSortedFragments;

int numFragments;
int max_score_index;
float max_score;



vector<class Score*> scoreFunctions[1<<(UPSTRANDBITS+DOWNSTRANDBITS+RELPOSBITS)];

int init_glocal(char *scorematrix) {
   initScoreFunctionPointers(scorematrix);
}

float do_chain()
{

  int i,j;
  int curr_max_index;
  float curr_max_score;
  float temp_score;
  int countFragments=0;
  int countChained=0;

  allNames.clear();

  /*
  if(!((argc ==3)||(argc==5)))
    {
      printf("Houston we have a problem Count is %d::Usage::QUADRATIC inputFileName scoreFileName [-a CUTOFF]\n",argc);
      exit(0);
    }


  if((argc==5)&&(strcmp(argv[3],"-a")!=0))
    {
      printf("Houston we have a problem::Usage::QUADRATIC inputFileName scoreFileName -a CUTOFF\n Count :%d",argc);
      exit(0);
    }
  */

  numFragments = fragments.size(); //readInput(argv[1]);

  if (numFragments > 10000) {
    //    assert(0);
    fprintf(stderr, "do_chain %d\n", numFragments);
  }

  if (numFragments == 0) {
    return 0.0;
  }


  
   //Call the sort here.

   sort(fragments.begin(), fragments.end(), seq1StartCompare);
  
  
   //   fprintf(stderr, "done sort\n");

   findAllNames( numFragments);
   //   fprintf(stderr, "N\n");
   storeIterators(numFragments);

   
   //   fprintf(stderr, "N&I\n");

  max_score_index=0;
  max_score =  fragments[0].totalScore = fragments[0].score;

  //  fprintf(stderr, "into loop\n");
  for(i=1;i<numFragments;i++)
    {
      curr_max_index =-1;
      curr_max_score=0;

      for(j=0;j<i;j++)
	{

	  //	  fprintf(stderr, "in loop %d %d\n",i,j);
	  if(fragments[i].seq1Start-fragments[j].seq1End > SEQ1CUTOFF )
	     //|| fragments[i].nameIter != fragments[j].nameIter)
	    {

	      temp_score=scoreAll(&fragments[j],&fragments[i]);
	    	      
	      if(temp_score>=curr_max_score)
		{
		  curr_max_score = temp_score;
		  curr_max_index =j;
		}
	     }
	}



        if(curr_max_index !=-1)
	{

	  fragmentSetScore(&fragments[i],&fragments[curr_max_index]);
  	  
	}
	// NOCHAIN
	else
	{
	      fragments[i].totalScore = fragments[i].score;
	}


	if(fragments[i].totalScore > max_score)
	  {
	    max_score= fragments[i].totalScore;
	    max_score_index = i;
	    
	  }
    }
  
  //  fprintf(stderr, "doneloop\n");
  return max_score;
}





float fragmentSetScore(Fragment * current,Fragment *owner) 
{
  
  current->totalScore =scoreAll(owner,current) + current->score;
  

  current->back = owner;

  return current->totalScore;
 
}




int relPos(Fragment *up,Fragment *down)
{
  int frag1Seq2Max,frag1Seq2Min,frag2Seq2Max,frag2Seq2Min;
  int lengthFrag1, lengthFrag2;

  
  if(up->nameIter != down->nameIter)
    {
      
      return UNRELATED;
    }
  
  


  frag1Seq2Max = Mymax(up->seq2Start,up->seq2End);
  frag1Seq2Min = Mymin(up->seq2Start,up->seq2End);


  frag2Seq2Max = Mymax(down->seq2Start,down->seq2End);
  frag2Seq2Min = Mymin(down->seq2Start,down->seq2End);

  lengthFrag1= frag1Seq2Max-frag1Seq2Min;
  lengthFrag2= frag2Seq2Max-frag2Seq2Min;

 



  /*      ------
       --------------  */
  
  if(frag1Seq2Min>=frag2Seq2Min && frag1Seq2Max <= frag2Seq2Max)
    {
      
 
      return BELOW;
      
    }
  

  /*  ---------------
         -------    */
  
 if(frag1Seq2Min<=frag2Seq2Min && frag1Seq2Max >= frag2Seq2Max)
    {
 
 
      
      return BELOW;
      
    }
  

 /*      --------
             -------    */
 if(frag1Seq2Min<frag2Seq2Min  &&  frag1Seq2Max < frag2Seq2Max )
   {
     if(((float)(frag1Seq2Max - frag2Seq2Min))>= RATIO * ((float)min(lengthFrag2,lengthFrag1)))
     {
        
       return BELOW;
      
       
     }
     else
       {
	 
 	 return RIGHT;
       }
   }

 /*    ------------
   -----------       */
 if(frag1Seq2Min>frag2Seq2Min  &&  frag1Seq2Max > frag2Seq2Max )
   {
     
     if(((float)(frag2Seq2Max - frag1Seq2Min))>= RATIO * ((float)min(lengthFrag2,lengthFrag1)))
     {
       
       
       return BELOW;
       
     }
     else
       {
	 return LEFT;
       }

   }
 

 printf("Incorrectly coded cases for relative positions \n");
 exit(0);
  
}


// OPN 0,1000,2000,2000       MIN   0,1.0,2.5,2.5   MAX    0,0,0,0  DIAGONAL  - 0.2,0.06,0.06,0.06 

/*
void initScoreFunctionPointers()
{
  
  int i ;
  
  Score *scoreObjectContinuation =new Score(0,0,0,0.2);
  Score *scoreObjectInversion =new Score(1000,1.0,0,0.06);
  Score *scoreObjectInverseTranslocation =new Score(2000,2.5,0,0.06);
  Score *scoreObjectTranslocation =new Score(2000,2.5,0,0.06);


  //Inverse Translocation and the TRanslocation have the same score ?!!?



  
  for(i=0;i< (1<< (UPSTRANDBITS+DOWNSTRANDBITS+RELPOSBITS));i++)
   {
     scoreFunctions[i].push_back(scoreObject);
   }
  


  //CONTINUATION
  scoreFunctions[POSITIVE<<UPSTRANDSHIFT|POSITIVE<<DOWNSTRANDSHIFT|RIGHT<<RELPOSSHIFT].push_back(scoreObjectContinuation);
  scoreFunctions[NEGATIVE<<UPSTRANDSHIFT|NEGATIVE<<DOWNSTRANDSHIFT|LEFT<<RELPOSSHIFT].push_back(scoreObjectContinuation);

  //INVERISON
scoreFunctions[POSITIVE<<UPSTRANDSHIFT|NEGATIVE<<DOWNSTRANDSHIFT|RIGHT<<RELPOSSHIFT].push_back(scoreObjectInversion);

scoreFunctions[NEGATIVE<<UPSTRANDSHIFT|POSITIVE<<DOWNSTRANDSHIFT|LEFT<<RELPOSSHIFT].push_back(scoreObjectInversion);

//INVERSETRANSLOCATION

scoreFunctions[NEGATIVE<<UPSTRANDSHIFT|POSITIVE<<DOWNSTRANDSHIFT|RIGHT<<RELPOSSHIFT].push_back(scoreObjectInverseTranslocation);

scoreFunctions[POSITIVE<<UPSTRANDSHIFT|NEGATIVE<<DOWNSTRANDSHIFT|LEFT<<RELPOSSHIFT].push_back(scoreObjectInverseTranslocation);

//TRANSLOCATION
scoreFunctions[POSITIVE<<UPSTRANDSHIFT|POSITIVE<<DOWNSTRANDSHIFT|LEFT<<RELPOSSHIFT].push_back(scoreObjectTranslocation);

scoreFunctions[NEGATIVE<<UPSTRANDSHIFT|NEGATIVE<<DOWNSTRANDSHIFT|RIGHT<<RELPOSSHIFT].push_back(scoreObjectTranslocation);


// POSPOSBELOW,NEGNEGBELOW

scoreFunctions[POSITIVE<<UPSTRANDSHIFT|POSITIVE<<DOWNSTRANDSHIFT|BELOW<<RELPOSSHIFT].push_back(scoreObjectInversion); 

scoreFunctions[NEGATIVE<<UPSTRANDSHIFT|NEGATIVE<<DOWNSTRANDSHIFT|BELOW<<RELPOSSHIFT].push_back(scoreObjectInversion); 


//NEGPOSBELOW, POSNEGBELOW


scoreFunctions[NEGATIVE<<UPSTRANDSHIFT|POSITIVE<<DOWNSTRANDSHIFT|BELOW<<RELPOSSHIFT].push_back(scoreObjectInverseTranslocation);

scoreFunctions[POSITIVE<<UPSTRANDSHIFT|NEGATIVE<<DOWNSTRANDSHIFT|BELOW<<RELPOSSHIFT].push_back(scoreObjectInverseTranslocation);

}

*/

int caseOfFragments(Fragment *up,Fragment *down)
{

  Fragment *temp;
  char upStrand;
  int count,positiveCount;
  
  count =0;positiveCount=0;
  temp = up;
   while(temp)
    {
      if(temp->strand==POSITIVE)
	positiveCount++;
      temp=temp->back;
      count++;
      if(count==MOMENTUM)
	break;
    }


   if (down->strand == POSITIVE)
     {
       positiveCount++;
       count++;
     }
   
   if(positiveCount <  count - positiveCount)
     {
       upStrand = NEGATIVE;
     }
   else if (positiveCount == count - positiveCount)
     {
       upStrand = up->strand;
     }
   else
     {
       upStrand = POSITIVE;
     }

  

 return upStrand<<UPSTRANDSHIFT |down->strand <<DOWNSTRANDSHIFT |relPos(up,down)<<RELPOSSHIFT;



}


void initScoreFunctionPointers(char *scoreFileName)
{

  
  ifstream SFP; 
  char line[255];

  SFP.open(scoreFileName);

  int ret_val;

  if(!SFP.good())
    {
      printf(" The score file is invalid");
      exit(0);

    }

  while(1)
    {
     
      SFP.getline(line,255);
      
      
      if( line[0]=='\0') 
	{
	  
	break;
	}

      createScoreFunctionObjects(line);
      
                  
    }
}

void  createScoreFunctionObjects(char * line)
{
  int i;
  int j;
  int rem[4];
  int remCases[MAXCASES],remObjects[MAXOBJECTS];
  int numCases;
  int numObjects;
  int cases [MAXCASES];
  float objects[MAXOBJECTS][4];
  char updir,downdir,relpos;

  Score * SFObjects[MAXOBJECTS];

 
  
 j=0;
 

  for(i=0;i<strlen(line);i++)
    {
      if(line[i]=='{' ||line[i]=='}')
	rem[j++]=i;
    }


  /*
  for(i=0;i<4;i++)
    {
      printf ("%d\t",rem[i]);
    }
  exit(0);

  */
  //forming cases

  numCases=0;

  for(i=rem[0];i<=rem[1];i++)
    {
      if(line[i]=='{' ||line[i]=='}'||line[i]==';')
	{
	  remCases[numCases++]=i;

	}
    }  

     numCases--;

    for(i=0;i<numCases;i++)
    {

      sscanf(&line[remCases[i]+1],"%c %c %c",&updir,&relpos,&downdir);
      //printf("%c %c %c",updir,downdir,relpos);

  

      cases[i]= charToCase(updir)<<UPSTRANDSHIFT | charToCase(downdir)<<DOWNSTRANDSHIFT |charToCase(relpos)<<RELPOSSHIFT;
    }
     
      
    
  numObjects=0;
  for(i=rem[2];i<=rem[3];i++)
    {
      if(line[i]=='{' ||line[i]=='}'||line[i]==';')
	{
	  remObjects[numObjects++]=i;

	}
     }

     numObjects--;

    for(i=0;i<numObjects;i++)
    {
      sscanf(&line[remObjects[i]+1],"%f %f %f %f",&objects[i][0],&objects[i][1],&objects[i][2],&objects[i][3]);
      //printf("hmm%f %f %f %f\n",objects[i][0],objects[i][1],objects[i][2],objects[i][3]);

SFObjects[i] = new Score(objects[i][0],objects[i][2],objects[i][3],objects[i][1]);
 
    }





for(i=0;i<numCases;i++)
{
for(j=0;j<numObjects;j++)
{
  scoreFunctions[cases[i]].push_back(SFObjects[j]);
  

}
}



     
      
    
  
}

int charToCase(char in)
{
   switch(in)
   {
      case '+': return POSITIVE;
case '-': return NEGATIVE;
case'R': return RIGHT;
case'L': return LEFT;
case'B':return  BELOW;
case'U':return  UNRELATED;

 default: exit(0);

 
   }
}




float scoreAll(Fragment *up,Fragment *down)
{
  int i;
  float ret_score=NEGINF;
  float temp_score;
  
  int ret_case;
  
 ret_case =caseOfFragments(up,down);

  for(i=0;i<scoreFunctions[ret_case].size();i++)
    {
      temp_score = scoreFunctions[ret_case][i]->getScore(up,down);

      
      if(temp_score > ret_score)
	{
	  ret_score = temp_score;
	}
   
    }

  if(ret_score ==  NEGINF)
    {
      printf("Score function case not handled::%d\n",ret_case);
      exit(0);
    }

  return ret_score;
  
}


int Mymax(int a,int b)
{
  if (a>=b)
    {
      return a;

    }
  else
    {
      return b;
    }
}


int Mymin(int a,int b)
{
  if (a<=b)
    {
      return a;

    }
  else
    {
      return b;
    }
}


int Myabs(int a)
{
  if(a < 0)
    return -a;

  else
    {
      return a;
    }
}

void findAllNames(int numFragments)
{
  int i;
  for(i=0;i<numFragments;i++)
    {
      allNames.insert(fragments[i].seq2Name);
      
    }
}



void storeIterators(int numFragments)
{
  int i;
  for(i=0;i<numFragments;i++)
    {
      fragments[i].nameIter = allNames.find(fragments[i].seq2Name);
    }
}

void insertInSortedOrder(int numFragments)
{
  int i;
  for(i=0;i<numFragments;i++)
    {
      scoreSortedFragments.insert(&fragments[i]);
      
    }
}




