#include<structs.h>
#include<glocal.h>
#include<io.h>


extern vector<Fragment>fragments;
extern SortedSet scoreSortedFragments;





//internal function that i dont need to care about.
char* rolltonum(char* str) 
{
  char *got1=0, *got2=0;
  int in=0, i=0;
  while (1)
 {
    if (str[i] == 0) 
      {
      break;
      }
    if (str[i] == ';' && got1 && got2){
        return got1;
    }
    if (isdigit(str[i])) {
      if (!in && (!i || isspace(str[i-1]))) { 
        if (got1) 
          got2 = &str[i];
        else 
          got1 = &str[i];
        in = 1;
      }
    }
    else if (in && (isspace(str[i]))) {
      if (got2) {
        got1 = got2; got2=0; in = 0;
      }
       in = 0;
    }
 
    else {
      got1=got2=(char*)(in=0);
    }
    i++;
  }
  return &str[i];
}


//reads one line of input at a time.
int getline(FILE *infile, hll *tt)
 {
  char temp[1024];
  char* help;
  int z, h;
  fgets(temp, 1024, infile);
  
  sscanf(temp,"%s",&tt->seq1Name);

  help = rolltonum(temp);
  z = sscanf(help, "%d %d;%n", &tt->seq1start, &tt->seq1end, &h);
  if (z<2)
    return 0;
  
  sscanf(help+h,"%s",&tt->seq2Name);
  
  help = rolltonum(help+h);

  if (sscanf(help,"%d %d; score = %f (%c)\n", &tt->seq2start,
             &tt->seq2end,&tt->score,&tt->strand)<3)
    return 0;
  return 1;
}


// output function to be called
void printFragment ( Fragment * curfrag )
{
        
  if ( curfrag == NULL ) return;

  printf ( "(%d %d)=(%d %d) %f %c [%f] s1:%s s2: %s\n",
	   curfrag->seq1Start,
	   curfrag->seq1End,
	   curfrag->seq2Start,
	   curfrag->seq2End,
	   curfrag->score,
	   (curfrag->strand==POSITIVE)?'+':'-',
	   curfrag->totalScore, 
	   curfrag->seq1Name,
	   curfrag->seq2Name
	   );

 

  /*    printf ( "(%d %d)=(%d %d) %f\n",
	   curfrag->seq1Start,
	   curfrag->seq1End,
	   curfrag->seq2Start,
	   curfrag->seq2End,
	   curfrag->score);*/
}


void printAllFragments(int numFragments)
{
  int i;
  for( i=0;i<numFragments;i++)
    {
      printFragment(&fragments[i]);

    }
  return;
}



// prints a chain upwards starting at the fragment called last.
int printChain(int last)
{
  Fragment *current;
  char *dummy;
  
  current =&fragments[last];
  printFragment(current);
  

  while(current->back)
    {
      current= current->back;
      printFragment(current );
            
    }

  return 0;

}
void swap(int *a, int *b)
{
  int temp;
  temp = *a;
  *a= *b;
  *b= temp;
}

// initialises the parameters for a fragment.
// note the swap at the end of this function.

Fragment createFragment(hll *temp)
{
  Fragment frag;
  frag.seq1Start= temp->seq1start;
  frag.seq1End= temp->seq1end;

  frag.seq2Start= temp->seq2start;
  frag.seq2End= temp->seq2end;
  frag.printFlag = FALSE;

  strcpy(frag.seq1Name,temp->seq1Name); 

  strcpy(frag.seq2Name,temp->seq2Name); 


  

  if(temp->strand=='+')
    frag.strand = POSITIVE;
 
  else if (temp->strand =='-')
    frag.strand = NEGATIVE;
  else
    {
      printf("Incorrect value for strand type/n");
      exit(0);
    }



  frag.score= temp->score;

  frag.back= NULL;

  frag.totalScore = 0;

  
    if(frag.seq1Start > frag.seq1End)
    swap(&(frag.seq1Start),&(frag.seq1End));

  return frag;

  
}




// reads the input file and returns the number of fragments read.
int readInput(char * fileName)
{
  hll tempInput;
  FILE * fp;
  int i=0;

  fp = fopen(fileName,"r");

  if(!fp)
    {
      printf(" Houston we have a problem  %s: Null file pointer \n",fileName);
      exit(0);
    }

  if(feof(fp))
    {
      printf("Houston we have a problem : Empty file \n");
      exit(0);
    }
  
 

  while(!feof(fp))
  {
    
    while (!feof(fp) && !getline(fp, &tempInput));
    
    if(feof(fp))
      break;

    
    
    // ignoring the low scoring fragments ?
    if (tempInput.score < CUTOFF )
      continue;
        
    
    //createfragment
   
    fragments.push_back(createFragment(&tempInput));
    i++;
    
         
  }
  
  return i;

}


void printAllChains(int numFragments,float cutOffScore)
{
  SortedSet ::iterator i;
  for(i= scoreSortedFragments.begin();i!=scoreSortedFragments.end();i++)
    {
      if( ((*i)->printFlag == FALSE) && (*i)->totalScore >=cutOffScore)
	{
	  if(printAllChainsDecidePrint(cutOffScore,*i))
	    {
	      printf("\nNewChain\n");
	      printAllChainsPrintChain(*i);
	      printAllChainsColor(*i);
	    }
	}
      

    }
  
}

// should i be adjusting the scores?
int printAllChainsPrintChain(Fragment *current)
{

  printFragment(current);


  while(current->back && current->back->printFlag == FALSE)
    {
      current= current->back;
      printFragment(current );

            
    }

  return 0;

  
}




int printAllChainsColor(Fragment *current)
{

  current->printFlag =TRUE;


  while(current->back && current->back->printFlag == FALSE)
    {
      current= current->back;
      current->printFlag =TRUE;
                  
    }

  return 0;

  
}

int printAllChainsDecidePrint(float cutOffScore,Fragment *current)
{
  int i;
  
  float currentIndexScore=current->totalScore;
  
  
    

  while(current->back && current->back->printFlag == FALSE)
    {
      current= current->back;
                       
    }
  if(current->back&&(currentIndexScore - current->back->totalScore)<cutOffScore)
    {
      return FALSE;
           
    }

  return TRUE;
}




