#ifndef STRUCTS
#define STRUCTS

//general defines
#include<stdio.h>
#include<vector>
#include<stdlib.h>
#include<iostream>
#include<limits.h>
#include<list>
#include<set>
#include<string.h>


#define INF LONG_MAX
#define NEGINF LONG_MIN

#define POSITIVE 1
#define NEGATIVE 0


#define SEQ1CUTOFF -10
#define CUTOFF 0
#define TRUE 1
#define FALSE 0


#define BELOW 0
#define RIGHT 1
#define LEFT 2
#define UNRELATED 3


#define MAXCASES 20
#define MAXOBJECTS 10 

#define UPSTRANDBITS  3
#define DOWNSTRANDBITS 3
#define RELPOSBITS 3
#define MOMENTUM 5

#define UPSTRANDSHIFT 0
#define DOWNSTRANDSHIFT UPSTRANDBITS
#define RELPOSSHIFT UPSTRANDBITS + DOWNSTRANDBITS

#define RATIO 0.8
#define NAMESIZE 257

using namespace std;

struct ltstr
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) < 0;
  }
};


typedef set<char *,ltstr> Name;

typedef struct Fragment
{
  int seq1Start,seq2Start,seq1End,seq2End;
  char strand;
  float score;
  float totalScore;
  struct Fragment *back;
  char seq1Name[NAMESIZE];
  Name::iterator nameIter;
  char seq2Name[NAMESIZE];
  char printFlag;
 
}Fragment;


struct scoreCompare
{
  bool operator()(Fragment *s1, Fragment *s2) const
  {
    return s1->totalScore > s2->totalScore;
  }
};








typedef set<Fragment*,scoreCompare> SortedSet;

typedef struct HitLocationList {
  int seq1start;
  int seq2start;
  int seq1end;
  int seq2end;
  float score;
  char strand;
  struct HitLocationList *next;
  struct HitLocationList *bkptr;
  float scoreSoFar;
  char seq1Name[NAMESIZE];
  char seq2Name[NAMESIZE];
} hll;







#endif
